package jp.hishidama.swing.popup;

import java.awt.Component;
import java.awt.event.KeyEvent;

import javax.swing.Action;
import javax.swing.ActionMap;
import javax.swing.JComponent;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.KeyStroke;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;
import javax.swing.text.DefaultEditorKit;
import javax.swing.text.JTextComponent;

import jp.hishidama.swing.action.DelegateAction;
import jp.hishidama.swing.action.TextDelegateAction;

/**
 * g|bvAbvj[.
 *
 * <p>
 * ftHgňȉ̃j[o^|bvAbvj[B
 * </p>
 * <ul>
 * <li>؂(<u>X</u>)</li>
 * <li>Rs[(<u>C</u>)</li>
 * <li>\t(<u>P</u>)</li>
 * <li>ׂđI(<u>A</u>)</li>
 * </ul>
 * ANVΏۃR|[lgɓo^ĂȂꍇ́Aj[͕\ȂB<br>
 * ႦJTreeł́uׂđIv͕\ȂB<br>
 * tɃRs[&amp;y[Xg͎ۂ͓삵Ȃꍇł蓖ĂĂ鎖̂ŁAقڏɕ\iIۂɓ삷Ƃ͌Ȃj
 *
 * <pre>
 * JTextField text = new JTextField();
 * JPopupMenu pmenu = new ExPopupMenu(text);
 * text.setComponentPopupMenu(pmenu);
 * comp.setComponentPopupMenu(pmenu); //̃R|[lgɓo^\AANV͂܂textɑ΂čs
 * </pre>
 *
 * @author <a target="hishidama" href=
 *         "http://www.ne.jp/asahi/hishidama/home/tech/java/swing/JPopupMenu.html"
 *         >Ђ</a>
 * @since 2009.04.19
 */
public class ExPopupMenu extends JPopupMenu implements PopupMenuListener {
	private static final long serialVersionUID = 164492326728598410L;

	protected JComponent component;

	/**
	 * RXgN^[.
	 * <p>
	 * j[IꂽہAŎw肳ꂽR|[lgɑ΂ăANVϏB
	 * </p>
	 *
	 * @param c
	 *            |bvAbvΏۃR|[lg
	 */
	public ExPopupMenu(JComponent c) {
		this.component = c;
		addPopupMenuListener(this);

		initPopupMenu();
	}

	protected transient ActionMap actionMap;

	protected void initPopupMenu() {
		actionMap = component.getActionMap();
		addMenus();
		actionMap = null;
	}

	protected void addMenus() {
		addCut();
		addCopy();
		addPaste();
		addSelectAll();
	}

	protected boolean addCut() {
		Action cut = actionMap.get("cut");
		return addDelegateTextMenu(component, "؂(X)", cut, 'X', KeyStroke
				.getKeyStroke(KeyEvent.VK_X, KeyEvent.CTRL_DOWN_MASK));
	}

	protected boolean addCopy() {
		Action copy = actionMap.get("copy");
		return addDelegateMenu("Rs[(C)", copy, 'C', KeyStroke.getKeyStroke(
				KeyEvent.VK_C, KeyEvent.CTRL_DOWN_MASK));
	}

	protected boolean addPaste() {
		Action paste = actionMap.get("paste");
		return addDelegateTextMenu(component, "\t(V)", paste, 'V', KeyStroke
				.getKeyStroke(KeyEvent.VK_V, KeyEvent.CTRL_DOWN_MASK));
	}

	protected boolean addSelectAll() {
		Action all = actionMap.get(DefaultEditorKit.selectAllAction);
		return addDelegateMenu("ׂđI(A)", all, 'A', KeyStroke.getKeyStroke(
				KeyEvent.VK_A, KeyEvent.CTRL_DOWN_MASK));
	}

	protected boolean addDelegateMenu(String text, Action action) {
		return addDelegateMenu(text, action, 0, null);
	}

	protected boolean addDelegateMenu(String text, Action action, int mnemonic,
			KeyStroke ks) {
		if (action != null) {
			action = new DelegateAction(component, action);
		}
		return addMenu(text, action, mnemonic, ks);
	}

	protected boolean addDelegateTextMenu(JComponent c, String text,
			Action action, int mnemonic, KeyStroke ks) {
		if (c instanceof JTextComponent) {
			JTextComponent tc = (JTextComponent) c;
			action = new TextDelegateAction(tc, action);
			return addMenu(text, action, mnemonic, ks);
		} else {
			return addDelegateMenu(text, action, mnemonic, ks);
		}
	}

	protected boolean addMenu(String text, Action action, int mnemonic,
			KeyStroke ks) {
		if (action != null) {
			JMenuItem mi = this.add(action);
			if (text != null) {
				mi.setText(text);
			}
			if (mnemonic != 0) {
				mi.setMnemonic(mnemonic);
			}
			if (ks != null) {
				mi.setAccelerator(ks);
			}
			return true;
		}
		return false;
	}

	// PopupMenuListener

	/**
	 * |bvAbv\OɌĂ΂B<br>
	 * Ŋej[enabledĐݒ肷B
	 */
	@Override
	public void popupMenuWillBecomeVisible(PopupMenuEvent e) {
		refresh(this);
	}

	protected void refresh(Component c) {
		if (c instanceof JMenuItem) {
			JMenuItem mi = (JMenuItem) c;
			refreshMenuItem(mi);
		}
		if (c instanceof JComponent) {
			JComponent jc = (JComponent) c;
			int sz = jc.getComponentCount();
			for (int i = 0; i < sz; i++) {
				refresh(jc.getComponent(i));
			}
		}
	}

	protected void refreshMenuItem(JMenuItem mi) {
		Action a = mi.getAction();
		if (a != null) {
			mi.setEnabled(a.isEnabled());
		} else {
			// mi.setEnabled(true);
		}
	}

	@Override
	public void popupMenuWillBecomeInvisible(PopupMenuEvent e) {
	}

	@Override
	public void popupMenuCanceled(PopupMenuEvent e) {
	}
}
